#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27, 16, 2);


const int currentPin = A0;
int sensitivity = 100;
int adcValue= 0;
int offsetVoltage = 2480;
double adcVoltage = 0;
double currentValue = 0;

const int voltageSensor = A1;

float vOUT = 0.0;
float vIN = 0.0;
float R1 = 30000.0;
float R2 = 7500.0;
int value = 0;
int power = 0;

void setup() 
{
  Serial.begin(9600);
  pinMode(currentPin, INPUT);
  pinMode(voltageSensor, INPUT);
  lcd.begin(16,2);
  lcd.init();
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("GAME START");
  lcd.setCursor(0,1);
  lcd.print("PEDAL FASTER!!");
  delay(1500);
  lcd.clear();
}
 
void loop()
{
  adcValue = analogRead(currentPin);
  Serial.print("Raw Current = ");
  Serial.print(adcValue);
  Serial.print("\t");
  adcVoltage = (adcValue / 1024.0) * 5000;
  Serial.print("\t");
  Serial.print(adcVoltage);
  Serial.print("\t");
  //Serial.println(adcVoltage);
  currentValue = ((adcVoltage - offsetVoltage)/ sensitivity);
  
  Serial.print("Current = " );
  Serial.print(currentValue);

  value = analogRead(voltageSensor);
  vOUT = (value * 5.0) / 1024.0;
  vIN = vOUT / (R2/(R1+R2));
  Serial.print("\t");
  Serial.print("Voltaget = ");
  Serial.println(vIN);

  power = vIN*currentValue;
  
  lcd.setCursor(0,0);
  lcd.print("POWER: " + String(power) + " W");
  lcd.setCursor(0,1);
  lcd.print("V: " + String(vIN) + " V");
  lcd.setCursor(9,1);
  lcd.print("I: " + String(currentValue) + " A");
  delay(500);
  lcd.clear();
}
